<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';	
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminPathAnalyzerPage', 'TwatchAdminPage' );
	
	class AdminPathAnalyzerPage extends AdminPathAnalyzerPageParent {
		
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			require $twatch->path( 'lib/PathAnalyzerDiag.php' );
	
			$this->toRoot = '..';
			$this->title = 'Admin: Path Analyzer';
			
			$this->init();
			
			$this->inHead->pl( '<script type="text/javascript" src="../js/AdminPathAnalyzer.js"></script>' );
			
			$this->selected_left_button = 4;
			
			$this->open( $p );
			
			$entities = &$twatch->config->getList( TwatchConfig::ENTITIES );
			$pathAnalyzer = &$twatch->config->get( TwatchConfig::PATH_ANALYZER ); 
			$defPathAnalyzer = $twatch->config->getDefault( TwatchConfig::PATH_ANALYZER );
			$installed = $twatch->state->get( TwatchState::PATH_ANALYZER_INSTALLED );
			
			$pathAnalyzerDiag = new TwatchPathAnalyzerDiag();
			$pathAnalyzerDiag->load();
		
			
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			$p->rel();
			$ents = new ArdeAppender( ', ' );
			foreach( $entities as $entity ) {
				$ents->append( $entity->id.": '".$entity->name."'" );
			}
			
			$p->pl( '	entities = { '.$ents->s.' };' );
			$p->pl( '	pathAnalyzer = new AdminPathAnalyzer( '.$pathAnalyzer->adminJsObject().', '.($installed?'true':'false').', '.$defPathAnalyzer->adminJsObject().' );' );
			$p->pl( '	pathAnalyzer.insert();' );
			$p->pl( '	diagHolder = new DiagHolder( '.$pathAnalyzerDiag->jsObject().' );' );
			$p->pl( '	diagHolder.insert();' );
			$p->pl( '/*]]>*/</script>' );
			
			
			$this->close( $p );
		}
	}
	
	$twatch->applyOverrides( array( 'AdminPathAnalyzerPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminPathAnalyZerPage', $twatch );
	
	$page->render( $p );
	
?>