<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	$adminConfig = true;
	require_once dirname(__FILE__).'/../../lib/RecGlobalHead.php';
	require_once $twatch->path( 'lib/TimeZone.php' );
	
	loadConfig();
	
	
	
	class AdminGeneralRec {
		
		public $xhtml;
		
		public function __construct( $xhtml ) { $this->xhtml = $xhtml; }
		
		public function performAction( ArdePrinter $p, $action ) {
			global $twatch;
			if( $action == 'set_time_zone' ) {
			
				$tz = TwatchTimeZone::fromParams( $_POST );
				
				$origTz = TwatchTimeZone::fromConfig();
				
				if( $tz->isEquivalent( $origTz ) ) throw new TwatchUserError( 'nothing to change' );
				
				$tz->applyToConfig();
				
				if( !$this->xhtml ) {
					$p->pl( '<successful />' );
				}
			
			} elseif( $action == 'restore_time_zone' ) {
				
				$twatch->config->restoreDefault( TwatchConfig::TIME_DIFFERENCE );
				$twatch->config->restoreDefault( TwatchConfig::TIME_ZONE_NAME );
				
				$tz = TwatchTimeZone::fromConfig();
				
				if( !$this->xhtml ) {
					$tz->printXml( $p, 'result' );
					$p->nl();
				}
			
			} elseif( $action == 'upgrade_cookie_keys' ) {
				TwatchCookieKeys::upgradeKeys();
				if( !$this->xhtml ) {
					$p->pl( '<successful />' );
				}
			} elseif( $action == 'upgrade_admin_cookie' ) {
				TwatchAdminCookie::upgradeSecret();
				if( !$this->xhtml ) {
					$p->pl( '<successful />' );
				}
			} elseif( $action == 'update_def_lang' ) {
				$i = ArdeParam::str( $_POST, 'i' );
				if( !$twatch->localeExists( $i ) ) throw new ArdeException( "Locale '".$i."' doesn't exist." );
				$twatch->config->set( $i, TwatchConfig::DEFAULT_LANG );
				if( !$this->xhtml ) {
					$p->pl( '<successful />' );
				}
			} elseif( $action == 'change_log_when' ) {

				$when = TwatchExpression::fromParam( ArdeParam::str( $_POST, 'w' ) );
				$res = $when->isValid();

				if( $res !== true ) {
					$e = new TwatchUserError( '"when" has Syntax Error' );
					$e->safeExtras[] = $res;
					throw $e;
				}
				if( ardeEquivOrderedArrays( $when->a, $twatch->config->get( TwatchConfig::LOGGER_WHEN ) ) ) {
					throw new TwatchUserError( 'Nothing to Change' );
				}
				$oldWhen = new TwatchExpression( $twatch->config->get( TwatchConfig::LOGGER_WHEN ), null );
				$oldWhen->uninstall();
				$when->install();
				$twatch->config->set( $when->a, TwatchConfig::LOGGER_WHEN );
				
				if( !$this->xhtml ) {
					$p->pl( '<successful />' );
				}
				
			} else {
				throw new TwatchException( 'unknown action '.$action );
			}
		}
	}
	
	$twatch->applyOverrides( array( 'AdminGeneralRec' => true ) );
	
	$rec = $twatch->makeObject( 'AdminGeneralRec', $xhtml );
	
	if( !isset( $_POST['a'] ) ) throw new TwatchException( 'Action was not sent' );
	
	$rec->performAction( $p, $_POST['a'] );
	
	$p->end();
?>