<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminWebsitesPage', 'TwatchAdminPage' );
	
	class AdminWebsitesPage extends AdminWebsitesPageParent {
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			$this->title = 'Websites';
			$this->toRoot = '..';
			
			$this->init();
			
			$this->inHead->pl( '<script type="text/javascript" src="../js/Website.js"></script>' );
		
			$this->selected_left_button = 1;
			
			$this->open( $p );
			
			$p->pl( '<div class="help" style="float:right" /><a href="http://www.tracewatch.com/doc/websites/">Help<img src="'.$twatch->baseUrl( $this->toRoot, 'img/help.png' ).'" alt="" /></a></div>' );
			
			$p->pl( '<h1>Websites</h1>' );
			
			$wss = $twatch->config->getList( TwatchConfig::WEBSITES );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			$p->rel();
			$p->pl( '	websiteList = new WebsiteList( null );' );
			$p->pl( '	websiteList.insert();', 0 );
			foreach($wss as $k => $w) {
				$p->pl( 'websiteList.addWebsite( '.$w->js_object().' );' );
			}
			$p->rel();
			$p->pl( '/*]]>*/</script>' );
			
			$this->close( $p );
		}
	}
	
	$twatch->applyOverrides( array( 'AdminWebsitesPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminWebsitesPage' );
	
	$page->render( $p );
	
	
?>