<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/

	require_once $ardeBase->path( 'lib/ArdeXmlPrinter.php' );
	class ArdePage {
		var $title = '';
		
		var $toRoot = '';
		
		var $app;
		var $inHead;
		
		var $inList;

		var $main_center = false;
		
		public $doublePadBody = false;
		
		var $top_buttons=array();
		var $selected_top_button=-1;
		var $left_buttons=array();
		var $selected_left_button=-1;
		var $pri_buttons=array();
		var $selected_pri_button=-1;
		var $sec_buttons=array();
		var $selected_sec_button=-1;

		function __construct( ArdeApp $app ) {
			$this->inHead = new ArdeJobPrinter();
			$this->inList = new ArdeJobPrinter();
			$this->app = $app;
		}
		

		protected function printInLangCont( ArdePrinter $p ) {}
		
		public $subTitle = 'Website Statistics';
		
		function printHeader( ArdePrinter $p, $rightToLeft = false ) {
			global $ardeBase;
			
			$p->pl( '<head>' );
			
			$p->pl( '	<title>'.$this->title.'</title>' );
			
			$p->pl( '	<meta http-equiv="content-type" content="text/html; charset=utf-8" />' );
			$p->pl( '	<link rel="stylesheet" href="'.$this->app->baseUrl( $this->toRoot, 'css/main.css' ).'" />' );
			if( $rightToLeft ) {
				$p->pl( '	<link rel="stylesheet" href="'.$this->app->baseUrl( $this->toRoot, 'css/main_rtl.css' ).'" />' );
			}
			
			$p->hold( 1 );
			$this->inHead->flush( $p );
			$p->relnl();
			
			$p->pl( '</head>' );
			$p->pl( '<body>' );
			$p->pl( '	<div id="lang_cont">', 1 );
			$this->printInLangCont( $p );
			$p->rel();
			$p->pl( '	</div>' );
			$p->pl( '	<h1 class="main"><a href="http://www.tracewatch.com/"><img alt="TraceWatch" title="TraceWatch" src="'.$this->app->baseUrl( $this->toRoot, 'img/tracewatch'.($rightToLeft?'_rtl':'').'.gif' ).'" width="217" height="95" style="border:0px" /><span>'.$this->subTitle.'</span></a></h1>' );
			$p->pl( '	<div id="top_bar">' );
			$p->pl( '		<div id="top_bar_inside">' );
			$p->pl( '			<div class="clear"></div>' );
			$p->pl( '			<div class="list">&nbsp;', 1 );
			$this->inList->flush( $p );
			$p->relnl();
			$p->pl( '			</div>', 0 );
			if( count( $this->top_buttons ) ) {
				$p->pl( '<ul id="top_nav">', 1 );
				foreach( $this->top_buttons as $i => $button ) {
					$p->pn( '<li>' );
					if( $this->selected_top_button != $i ) $p->pn( '<a href="'.$button[1].'">' );
					$p->pn( $button[0] );
					if( $this->selected_top_button != $i ) $p->pn( '</a>' );
					$p->pl( '</li>' );
				}
				$p->rel();
				$p->pl( '</ul>' );
			}
			$p->rel();
			$p->pl( '			<div class="clear"></div>' );
			$p->pl( '		</div>' );
			$p->pl( '	</div>', 0 );
			if(count($this->left_buttons)) {
				$p->pl( '<table id="top_cont" cellpadding="0" cellspacing="0" border="0">' );
				$p->pl( '<tr>' );
				$p->pl( '	<td id="left_col">' );
				$p->pl( '		<ul class="nav">', 1 );
				foreach($this->left_buttons as $i => $button) {
					$p->pn( '<li '.($this->selected_left_button==$i?'class="selected" ':'').'>' );
					if( $this->selected_left_button != $i ) $p->pn( '<a href="'.$button[1].'">' );
					$p->pn( $button[0] );
					if( $this->selected_left_button != $i ) $p->pn( '</a>' );
					$p->pl( '</li>' );
				}
				$p->rel();
				$p->pl( '		</ul>' );
				$p->pl( '	</td>' );
				$p->pl( '	<td id="main" class="'.($this->doublePadBody?'pad_double':'pad_std').'"'.($this->main_center?' style="text-align:center;"':'').'>', 1 );
			} else {
				$p->pl( '<div id="main" class="'.($this->doublePadBody?'pad_double':'pad_std').'">', 1 );
			}
		}
		
		function printToFooter( ArdePrinter $p ) {
			$p->relnl();
			if( count( $this->left_buttons ) ) {
				$p->pl( '	</td>' );
				$p->pl( '</tr></table>' );
			} else {
				$p->pl( '</div>' );
			}
			$p->rel();
		}
		
		function printFooter( ArdePrinter $p ) {
			$p->pl( '	<div lang="en-US" xml:lang="en-US" id="footer">' );
			$p->pn( '		<div class="inside">', 1 );
			$this->printInFooter( $p );
			$p->rel();
			$p->pl( '		</div>' );
			$p->pl( '		<div class="break"></div>' );
			$p->pl( '	</div>' );
		}
		
		function printInFooter( ArdePrinter $p ) {}
		
		function end( ArdePrinter $p ) {
			$p->pl( '</body>' );
		}
		
		function close( ArdeXmlPrinter $p ) {
			$this->printToFooter( $p );
			$p->footer->flush( $p );
			$this->end( $p );
			$p->end();
		} 
	}	
?>