<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/lib/PageGlobal.php';	
	
	require_once $twatch->path( 'data/DataLatest.php' );

	$twatch->makeParentClass( 'LatestPage', 'TwatchPage' );
	
	class LatestPage extends LatestPageParent {
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase, $ardeUser;
			require_once $twatch->path( 'lib/EntityV.php' );
			require_once $twatch->path( 'lib/Reader.php' );
			
			
			
			$this->toRoot = '.';
			
			$this->init();
			
			
			
			$this->inHead->pl( '<script type="text/javascript" src="js/Latest.js"></script>' );
			
			$this->title = 'Latest Visitors';
			
			$this->selected_top_button = 1;
			
			
			$this->addExtraConfig( TwatchLatestPage::$defaults );
			
			$this->open( $p );
			
			$entities = &$twatch->config->getList( TwatchConfig::ENTITIES );
			$latestPage = &$twatch->config->get( TwatchConfig::LATEST_PAGE );
			$visitorTypes = &$twatch->config->getList( TwatchConfig::VISITOR_TYPES );
			
			$website = $twatch->config->get( TwatchConfig::WEBSITES, $this->websiteId );
			
			$sessionR = new TwatchSessionReader( $website->getSub() );
			
			if( isset( $_GET[ 'start' ] ) ) $start = (int)$_GET[ 'start' ];
			else $start = 0;
			
			$entityFilters = array();
			if( isset( $_GET['f'] ) ) {
				$fs = explode( '_', $_GET['f'] );
				for( $i = 0; $i < count( $fs ); $i += 2 ) {
					$entityId = (int)$fs[ $i ];
					if( !isset( $entities[ $entityId ] ) ) throw new TwatchException( 'invalid filter entity id '.$entityId );
					if( isset( $entityFilters[ $entityId ] ) ) throw new TwatchException( 'duplicate entity id '.$entityId );
					if( !isset( $fs[ $i + 1 ] ) ) throw new TwatchException( 'entity value id not sent' );
					$entityVId = ardeStrToU32( $fs[ $i + 1 ] );
					$entityFilters[ $entityId ] = $entityVId;
				}
			}
			
			if( !$ardeUser->user->hasPermission( TwatchUserData::VIEW_IPS ) ) {
				if( isset( $entityFilters[ TwatchEntity::IP ] ) || isset( $entityFilters[ TwatchEntity::PIP ] ) || isset( $entityFilters[ TwatchEntity::RIP ] ) || isset( $entityFilters[ TwatchEntity::FIP ] ) ) {
					throw new TwatchUserError( 'Premission Denied, You cannot filter by IP.' );
				}
			}
			
			if( !$ardeUser->user->hasPermission( TwatchUserData::VIEW_COOKIE_IDS ) ) {
				if( isset( $entityFilters[ TwatchEntity::PCOOKIE ] ) || isset( $entityFilters[ TwatchEntity::SCOOKIE ] ) ) {
					throw new TwatchUserError( 'Premission Denied, You cannot filter by ID.' );
				}
			}
			
			if( !$ardeUser->user->hasPermission( TwatchUserData::ADMINISTRATE ) ) {
				if( isset( $entityFilters[ TwatchEntity::ADMIN_COOKIE ] ) ) {
					throw new TwatchUserError( 'Permission Denied, You cannot filter by admin cookie' );
				}
			}
			
			$visitorTypeFilter = array();
			if( isset( $_GET[ 'vt' ] ) && !empty( $_GET['vt'] ) ) {
				$vts = explode( '_', $_GET['vt'] );
				foreach( $vts as $vt ) {
					$visitorTypeId = (int)$vt;
					if( !isset( $visitorTypes[ $visitorTypeId ] ) ) throw new TwatchException( 'invalid visitor type id '.$visitorTypeId );
					if( in_array( $visitorTypeId, $visitorTypeFilter ) ) throw new TwatchException( 'duplicate visitor type id '.$visitorTypeId );
					$visitorTypeFilter[] = $visitorTypeId;
				}
			} else {
				$visitorTypeFilter = $latestPage->defaultVtSelection;
			}
			
			if( $ardeUser->user->hasPermission( TwatchUserData::VIEW_ADMIN_IN_LATEST ) ) $forceExcludeVt = null;
			else $forceExcludeVt = TwatchVisitorType::ADMIN;
			
			$res = $sessionR->getLatestSessions( $start, $latestPage->perPage, $entityFilters, $visitorTypeFilter, $forceExcludeVt );
			
			
			
			$latestPage->init( $entityFilters, $visitorTypeFilter, $start, $sessionR->more, $sessionR->online );
			
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$p->hold( 1 );
			$this->initJsPage( $p, array( 'Update', 'VID', 'SID', 'd', 'h', 'm', 's', 'next page', 'prev. page', 'Please select something to search for', 'Search', 'Select', 'loading', 'Online', 'No Visitors', 'Copy to Clipboard', 'Filter Latest Visitors', 'Remove Filter', 'add', 'reset', 'Country', 'Unknown Country', 'Clear', 'already have filter of the same type', 'Sorry, You don\'t have permission', 'next {number}', 'prev {number}', 'Visitors' ) );
			$p->rel();
			
			$ents = new ArdeAppender( ', ' );
			foreach( $twatch->config->getList( TwatchConfig::ENTITIES ) as $entity ) {
				$ents->append( $entity->id.": ".$entity->minimalJsObject() );
			}
			
			$sEntities = array();
			$sEntities[ TwatchEntity::IP ] = true;
			foreach( $twatch->config->getList( TwatchConfig::RDATA_WRITERS ) as $dataWriter ) {
				if( $dataWriter->entityId == TwatchEntity::IP ) continue;
				$sEntities[ $dataWriter->entityId ] = true;
			}
			$sEntities[ TwatchEntity::PAGE ] = true;
			$sEnts = new ArdeAppender( ', ' );
			foreach( $sEntities as $id => $v ) $sEnts->append( $id.':true' );
			
			$p->pl( "	ardePreloadFlash( baseUrl+'fl/set_clipboard.swf' );" );
			$p->pl( "	ardePreloadImage( twatchUrl+'img/filter.gif' );" );
			$p->pl( "	ardePreloadImage( twatchUrl+'img/filter_add.gif' );" );
			$p->pl( "	ardePreloadImage( baseUrl+'img/wait.gif' );" );
			$p->pl( '	entities = { '.$ents->s.' };' );
			$p->pl( '	searchableEntities = { '.$sEnts->s.' };' );
			$p->pl( '	latestPage = '.$latestPage->jsObject().';' );
			$p->pl( '	latestPage.insertHeader();' );
			$p->hold( 1 );
			if( !count( $sessionR->sessions ) ) $p->pl( 'latestPage.noSessions();' );
			else {
				foreach( $sessionR->sessions as &$session ) {
					$p->pl( $session->jsObject( $latestPage ).'.insert();' );
				}
			}
			$p->rel();
			$p->pl( '	latestPage.insertFooter();');
			$p->pl( '/*]]>*/</script>');
			
			
			
			$this->close( $p );
		}
	}

	$twatch->applyOverrides( array( 'LatestPage' => true ) );
	
	$page = $twatch->makeObject( 'LatestPage', $twatch );
	
	$page->render( $p );
	
?>