<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	$twatch->makeParentClass( 'TwatchAdminPage', 'TwatchPage' );

	class TwatchAdminPage extends TwatchAdminPageParent {
		
		public function init() {
			$this->selected_top_button = 3;
			$this->selected_left_button = 0;
			$this->adminPage = true;
			parent::init();
		}
		public function printHeader( ArdePrinter $p, $dummy = false ) {
			global $twatch;
			
			
			
			
			parent::printHeader( $p, $dummy );
		}
		
		protected function loadLocale() {
			global $twatch;
			if( $this->selectedLocaleId != 'English' ) {
				$twatch->loadLocale( 'English' );
			}
		}
		
		public function printRecLang( ArdePrinter $p ) {}
		
		public function setLeftButtons() {
			global $twatch;
			
			$url = new ArdeUrlWriter();
			$url->setParam( 'website', $this->websiteId, 1 );
			$url->setParam( 'lang', $this->selectedLocaleId, $twatch->config->get( TwatchConfig::DEFAULT_LANG ) );
			$url->setParam( 'profile', $twatch->profile, 'default' );
			$this->left_buttons = array(
				 array( 'Main', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/' ) ) )
				,array( 'Websites',$url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/websites.php' ) ) )
				,array( 'Stats Pages', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/stats_pages.php' ) ) )
				,array( 'Latest Visitors', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/latest.php' ) ) )
				,array( 'Path Analyzer', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/path_analyzer.php' ) ) )
				,array( 'Counters', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/counters.php' ) ) )
				,array( 'Entities', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/entities.php' ) ) )
				,array( 'User Agents', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/user_agents.php' ) ) )
				,array( 'Search Engines', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/search_engines.php' ) ) )
				,array( 'Visitor Types', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/visitor_types.php' ) ) )
				,array( 'Install', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/install.php' ) ) )
				,array( 'Uninstall', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/uninstall.php' ) ) )
				,array( 'Admin Cookie', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/admin_cookie.php' ) ) )
				,array( 'Comments', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/comments.php' ) ) )
				,array( 'Import', $url->getAddressUrl( $twatch->url( $this->toRoot, 'admin/import.php' ) ) )
			);
		}
	}
	
	$twatch->applyOverrides( array( 'TwatchAdminPage' => true ) );
?>