<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/lib/PageGlobal.php';	

	$twatch->makeParentClass( 'PathAnalysisPage', 'TwatchPage' );
		
	class PathAnalysisPage extends PathAnalysisPageParent {
		
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			$this->title = 'Path Analysis';
			$this->toRoot = '.';
			
			$this->init();
			
			$this->selected_top_button = 2;
			
			$this->inHead->pl( '<script type="text/javascript" src="js/PathAnalysis.js"></script>' );
			
			$this->open( $p );
		
			$pathAnalyzer = $twatch->config->get( TwatchConfig::PATH_ANALYZER );
		
			$p->pl( '<div class="margin_std" style="direction:ltr">' );
			$p->pl( '	<script type="text/javascript">/*<![CDATA[*/' );
			$p->hold(2);
			$this->initJsPage( $p );
			$p->rel();
			$p->pl( '		pathAnalyzer = '.$pathAnalyzer->jsObject( 1000, 600, 'rec/rec_paths.php', $this->websiteId ).';' );
			$p->pl( '		pathAnalyzer.insert();' );
			$p->pl( '	/*]]>*/</script>' );
			$p->pl( '</div>' );
			
			$this->close( $p );
			
		}
	}
	
	$twatch->applyOverrides( array( 'PathAnalysisPage' => true ) );
	
	$page = $twatch->makeObject( 'PathAnalysisPage', $twatch );
	
	$page->render( $p );
	
?>